
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class Zone {
  Pave[] paves; int no;
  
  Zone(int n,Pave... ps) { paves=ps; no=n; }
  
  void colorer(int c) { for (Pave p : paves()) p.colorer(c); }
  Pave[] paves() { return paves; }
  
  Zone suivante(boolean s) {
    if (s) {
      if (this==tco.z0) return tco.z5;
      if (this==tco.z1) return tco.z5;
      if (this==tco.z5) return tco.z4;
      if (this==tco.z4) return tco.z3;
      if (this==tco.z3) return tco.z2;
      if (this==tco.z2) if (tco.a0.directe()) return tco.z0; else return tco.z1;
    } else {
      if (this==tco.z0) return tco.z2;
      if (this==tco.z1) return tco.z2;
      if (this==tco.z5) if (tco.a1.directe()) return tco.z0; else return tco.z1;
      if (this==tco.z4) return tco.z5;
      if (this==tco.z3) return tco.z4;
      if (this==tco.z2) return tco.z3;
    }
    return null;
  }
}

class Aiguille {
  boolean etat=true;
  Pave pave;
  
  Aiguille(Pave p) { pave=p; }
  
  boolean directe() { return etat; }
  void manoeuvrer() { pave.manoeuvrer(); etat=!etat; }
  void directer() { if (directe()) return; manoeuvrer(); }
}

class Signal {
  Pave pave;
  int c; // couleur
  boolean sens=true; // false : sens pair   true : sens impair  Pave pave;
  
  Signal(Pave p,boolean s) { pave=p; sens=s; }
  void feu(int c) { pave.feu(c); this.c=c; }
  boolean ferme() { return c==COULEUR_ROUGE; } // !!! autres couleurs
  boolean sensImpair()  { return sens; }
}

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //

class Composants { 

Pave pz3c=new PaveArcN(0,IMPAIR,3).symetrie(),
     pz3b=new PaveDroitN(PI,PAIR,5),
     pz3a=new PaveSignal(PI,PAIR,COULEUR_JAUNE).retraitDroit(),
     
     pz4e=new PaveSignal(PI,IMPAIR,COULEUR_JAUNE).rotation(2).retraitGauche(),
     pz4d=new PaveDroitN(PI,PAIR,5),
     pz4c=new PaveArcN(0,PAIR,3),
     
     // voie B
     pz2d=new PaveArc(PI,PAIR).rotation(2).retraitDroit(),
     pz1a=new PaveSignal(0,PAIR,COULEUR_ROUGE).rotation(2).retraitGauche(),
     pz1b=new PaveDroitN(0,IMPAIR,2),
     pz1c=new PaveSignal(0,IMPAIR,COULEUR_ROUGE).retraitDroit(),
     pz5d=new PaveArc(PI,IMPAIR).rotation(2).symetrie().retraitGauche(),
     // voie A
     pz3d=new PaveArcN(0,PAIR,3).rotation(2),
     pz3e=new PaveSignal(0,IMPAIR,COULEUR_ROUGE).retraitDroit(),
     pz2a=new PaveDroit(0,IMPAIR).retraitGauche(),
     pz2b=new PaveAiguille(0,IMPAIR),
     pz2c=new PaveDroit(0,IMPAIR).retraitDroit(),
     pz0a=new PaveSignal(0,PAIR,COULEUR_ROUGE).rotation(2).retraitGauche(),
     pz0b=new PaveDroitN(0,IMPAIR,2),
     pz0c=new PaveSignal(0,IMPAIR,COULEUR_ROUGE).retraitDroit(),
     pz5a=new PaveDroit(0,IMPAIR).retraitGauche(),
     pz5b=new PaveAiguille(0,PAIR).symetrie(),
     pz5c=new PaveDroit(0,IMPAIR).retraitDroit(),
     pz4a=new PaveSignal(0,PAIR,COULEUR_ROUGE).rotation(2).retraitGauche(),
     pz4b=new PaveArcN(0,IMPAIR,3).symetrie().rotation(2); // modifie


 //{xa,xb,ax,bx, ya,yb,ay,by};

  BoutonItineraire xa=new BoutonItineraire(0,"XA"), // boutons d'itineraires
       xb=new BoutonItineraire(1,"XB"),
       ax=new BoutonItineraire(2,"AX"),
       bx=new BoutonItineraire(3,"BX"),
       
       ya=new BoutonItineraire(4,"YA"),
       yb=new BoutonItineraire(5,"YB"),
       ay=new BoutonItineraire(6,"AY"),
       by=new BoutonItineraire(7,"BY");

  BoutonItineraire[] itineraires={xa,xb,ax,bx, ya,yb,ay,by};
  
  Aiguille a0=new Aiguille(pz2b),
           a1=new Aiguille(pz5b);
           
 Aiguille[] aiguilles={a0,a1};
         
  Zone z0=new Zone(0,pz0a,pz0b,pz0c),
       z1=new Zone(1,pz1a,pz1b,pz1c),
       z2=new Z2(pz2a,pz2b,pz2c,pz2d),
       z3=new Z3Z4(pz3e,3,pz3a,pz3b,pz3c,/*px,*/pz3d,pz3e),
       z4=new Z3Z4(pz4a,4,pz4a,pz4b,pz4c,/*py,*/pz4d,pz4e), // py mal place
       z5=new Z5(pz5a,pz5b,pz5c,pz5d);
  
  Zone[] zones={z0,z1,z2,z3,z4,z5};
       
  Signal s1=new Signal(pz4e,IMPAIR), // S1
         s2=new Signal(pz3a,PAIR), // S2
         
         c1=new Signal(pz3e,IMPAIR), // C1
         c2=new Signal(pz4a,PAIR), // C2
         c3=new Signal(pz0c,IMPAIR), // C3
         c4=new Signal(pz0a,PAIR), // C4
         c5=new Signal(pz1c,IMPAIR), // C5
         c6=new Signal(pz1a,PAIR); // C6
         
 Signal[] signaux={s1,s2}; Signal[] carres={c1,c2, c3,c4, c5,c6};
   
  BoutonCommande bs1= new BoutonCommande(1,"<>",COULEUR_VERTE_FONCEE,COULEUR_OR,2), // fleche d'or  #D3D3D3
         bs2= new BoutonCommande(1,"<>",COULEUR_VERTE_FONCEE,COULEUR_BLEUE,1), // train bleu
         bma1=new BoutonCommande(2,"M/A",COULEUR_ROUGE,COULEUR_OR,2), // fleche d'or
         bma2=new BoutonCommande(2,"M/A",COULEUR_ROUGE,COULEUR_BLEUE,1); // train bleu
         
  Suivi bz0=new Suivi(),bz1=new Suivi(),bz2=new Suivi(),
        bz3=new Suivi(),bz4=new Suivi(),bz5=new Suivi();

  Suivi[] boutonsTrains={bz0,bz1,bz2,bz3,bz4,bz5};

 //{xa,xb,ax,bx,ya,yb,ay,by};
 
 class Z3Z4 extends Zone {  // problemes avec occupation
    Pave pave;
    Z3Z4(Pave p,int n,Pave... ps) { super(n,ps); pave=p;  } 
    void colorer(int c) { 
    if (c==COULEUR_BLANCHE)     pave.colorer(c); 
    else for (Pave p : paves()) p.colorer(c); 
  }
 }

 class Z2 extends Zone {
    Z2(Pave... ps) { super(2,ps); } 
    
    Pave[] paves() { 
      if (a0.directe()) return new Pave[] {pz2a,pz2b,pz2c}; 
      else              return new Pave[] {pz2a,pz2b,pz2d}; 
    }
  }

  class Z5 extends Zone {
    Z5(Pave... ps) { super(5,ps); }
    
    Pave[] paves() { 
      if (a1.directe()) return new Pave[] {pz5a,pz5b,pz5c}; 
      else              return new Pave[] {pz5d,pz5b,pz5c}; 
    }
  }


}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////