
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

abstract class Case { // case dans laquelle on peut mettre des paves, des boutons, ...
  abstract void dessiner(int x,int y,int n);
  void exec() {} // pour les boutons
}
 
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class CaseDouble extends Case {
  Case pave1,pave2;
  
  CaseDouble(Case p1,Case p2) { pave1=p1; pave2=p2; }
  
  public void dessiner(int x,int y,int n) {
    if (infos) pave1.dessiner(x,y,n);
    else       pave2.dessiner(x,y,n);
  }
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
class Tco extends Composants {  
  Case[][] paves=new Case[C][L];
  
  void dessiner() { int l,c; Case p;
    fill(COULEUR_FOND); rect(0,0,1100,500); // effacement du tco
    for (l=0; l<L; l++) for (c=0; c<C; c++) { // dessin de tous les paves
      p=paves[c][l];
      if (p!=null) p.dessiner(c,l,N); // test si pave
      if (grille) { noFill(); stroke(0); rect(B+c*9*N,B+l*9*N,9*N,9*N); } // dessin grille
    }
  }
  
  void calculPoints() { int l,c; Case x; Pave p; // calcul des points de toutes les formes
    for (l=0; l<L; l++) for (c=0; c<C; c++) { // pour toutes les cases
      x=paves[c][l]; // que pour les paves
      if (x instanceof Pave) { p=(Pave)x; for (Forme f:p.formes) f.points(); }
    }
  }
  
  int l=0,c=0; // ligne et colonne courante (pour remplissage)
  void construire() {// construction du TCO
    //add(new PaveDroit(0,true).rotation()); // test
    filler(4); add(new CaseDouble(new Nom("Z3"),bz3)); filler(4); add(new Nom("S2")); filler(5); add(new CaseDouble(new Nom("Z4"),bz4)); 
    aLaLigne();
    // voie du haut (2 signaux)
    filler(3); 
    add(pz3c); // courbe
    add(pz3b); // droit
    add(pz3a); // signal
    add(pz4e); // signal
    add(pz4d); // droit
    add(pz4c); // courbe
    aLaLigne(); 
    filler(10); add(new Nom("S1"));
    aLaLigne(); //filler(3); add(new PaveArc(false).symetrie()); add(new PaveArc(true)); 
      //aLaLigne(); filler(1);add(px); filler(16); add(py);
    aLaLigne(); 
    filler(8); add(new Nom("C6")); add(new Lettre('B')); add(new CaseDouble(new Nom("Z1"),bz1)); add(new Nom("C5")); filler(6); //add(pz4b); // courbe bas a droite
    aLaLigne(); 
    // voie B
    filler(4); add(new Nom("C1")); filler(1); add(new CaseDouble(new Nom("Z2"),bz2)); 
    add(pz2d); // arc
    add(pz1a); // signal
    add(pz1b); // droit
    add(pz1c); // signal
    add(pz5d); // arc
    add(new CaseDouble(new Nom("Z5"),bz5)); 
    aLaLigne();
    // voie A
    filler(1); 
    add(new Lettre('X')); 
    filler(1); 
    add(pz3d); // courbe
    add(pz3e); // signal
    add(pz2a); // droit
    add(pz2b); // aiguille
    add(pz2c); // droit
    add(pz0a); // signal
    add(pz0b); // droit
    add(pz0c); // signal
    add(pz5a); // droit
    add(pz5b); // aiguille
    add(pz5c); // droit
    add(pz4a); // signal
    add(pz4b); // modifie
    filler(1); 
    add(new Lettre('Y')); 
    aLaLigne();
    filler(6); add(new Nom("A0")); filler(1); add(new Nom("C4")); add(new CaseDouble(new Nom("Z0"),bz0)); add(new Lettre('A')); add(new Nom("C3")); filler(1); add(new Nom("A1")); filler(1); add(new Nom("C2")); 
    // les boutons
    aLaLigne();
    add(bs1); add(bma1); filler(3); add(xb); filler(1); add(bx); filler(4); add(by); filler(1); add(yb); filler(3); add(new BoutonControle(3,"T")); add(new BoutonControle(1,"G")); 
    aLaLigne();
    add(bs2); add(bma2); filler(3); add(xa); filler(1); add(ax); filler(4); add(ay); filler(1); add(ya); filler(3); add(new BoutonControle(4,"P")); add(new BoutonControle(2,"I")); 
}
  
  void aLaLigne() { l++; c=0; } // aller a la ligne
  void filler(int n) { c=c+n; } // remplissage
  void add(Pave p) { // ajout d'un pave, mise des coordonnees
    p.col=c; p.lin=l; // necessaire pour le calcul des points
    paves[c][l]=p; c+=p.largeur(); 
  }
  void add(Case p) { // ajout d'une case
    paves[c][l]=p; c++; 
  }  
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////